//+------------------------------------------------------------------+
//|                                         Momentum with Smooth.mq4 |
//|                      Copyright  2004, MetaQuotes Software Corp. |
//|                                       http://www.metaquotes.net/ |
//|                                                    Linuxser 2007 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2004, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net/"

#property indicator_separate_window
#property indicator_buffers 2
#property indicator_color1 DodgerBlue
#property indicator_color2 Tomato
#property indicator_level1  0.00
#property indicator_level2  100.00
#property indicator_levelcolor Green

//---- input parameters
extern int MomPeriod=14;
extern int Smooth   =  7; // Period of smoothing
extern int Style  = 0; 
extern bool MomCalc = false;
//---- buffers
double MomBuffer[];
double EMA_buffer[];
//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
   string short_name;
//---- indicator line
   SetIndexStyle(0,DRAW_LINE);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(0,MomBuffer);
   SetIndexBuffer(1,EMA_buffer);
//---- name for DataWindow and indicator subwindow label
   short_name="Rate of Change("+MomPeriod+") Smoothed Rate of Change("+Smooth+")";
   IndicatorShortName(short_name);
   SetIndexLabel(0,short_name);
//----
   SetIndexDrawBegin(0,MomPeriod);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Momentum                                                         |
//+------------------------------------------------------------------+
int start()
  {
   int i,counted_bars=IndicatorCounted();
   int limit=Bars-counted_bars;
//----
   if(Bars<=MomPeriod) return(0);
//---- initial zero
   if(counted_bars<1)
      for(i=1;i<=MomPeriod;i++) MomBuffer[Bars-i]=0.0;
//----
   i=Bars-MomPeriod-1;
   if(counted_bars>=MomPeriod) i=Bars-counted_bars-1;
   while(i>=0)
   
   if (MomCalc==False)
      {     
      MomBuffer[i]=(Close[i]-Close[i+MomPeriod])/Close[i+MomPeriod];      
      i--;
      }     
   
   else 
     {
      MomBuffer[i]=Close[i]*100/Close[i+MomPeriod];      
      i--;
     }
     
   for(i=0; i<limit-1; i++)  
   EMA_buffer[i]=iMAOnArray(MomBuffer,Bars,Smooth,0,MODE_SMA,i);  
   
   
  //---- Different Styles      
   if(Style == 1)
      {
         for(i=0; i<limit; i++)
         {
               
               SetIndexStyle(0,DRAW_HISTOGRAM);
               SetIndexStyle(1,DRAW_NONE);             
         } 
         }
         
    if(Style == 2)
      {
         for(i=0; i<limit; i++)
         {
               
               SetIndexStyle(0,DRAW_NONE);
               SetIndexStyle(1,DRAW_HISTOGRAM);             
         } 
         }
         
     if(Style == 3)
      {
         for(i=0; i<limit; i++)
         {
               
               SetIndexStyle(0,DRAW_LINE);
               SetIndexStyle(1,DRAW_NONE);             
         } 
         }
     
    if(Style == 4)
      {
         for(i=0; i<limit; i++)
         {
               
               SetIndexStyle(0,DRAW_NONE);
               SetIndexStyle(1,DRAW_LINE);             
         } 
         }                
         
     if(Style == 5)
      {
         for(i=0; i<limit; i++)
         {
               
               SetIndexStyle(0,DRAW_HISTOGRAM);
               SetIndexStyle(1,DRAW_LINE);             
         } 
         }                       
    
     if(Style == 6)
      {
         for(i=0; i<limit; i++)
         {
               
               SetIndexStyle(0,DRAW_LINE);
               SetIndexStyle(1,DRAW_HISTOGRAM);             
         } 
         }
     
     if(Style == 7)
      {
         for(i=0; i<limit; i++)
         {
               
               SetIndexStyle(0,DRAW_HISTOGRAM);
               SetIndexStyle(1,DRAW_HISTOGRAM);             
         } 
         }                  
   
     
   return(0);
  }
//+------------------------------------------------------------------+